//+------------------------------------------------------------------+
//|                                                     MovingLR.mq4 |
//|                                                           Candid |
//|                                                 candid.110mb.com |
//+------------------------------------------------------------------+
#property copyright "Candid"
#property link      "candid.110mb.com"
 
#property indicator_chart_window
#property indicator_buffers 1
//#property indicator_buffers 2

#property indicator_color1 Blue
//#property indicator_color2 Green
#property indicator_width1 2
//#property indicator_width2 2
 
extern int Frame = 20;             //  
extern int Shift = 0;              //  
extern int Sample = 0;          //  

string OName = "MovingLR";   

int PreBars;
datetime BarTime;

int bFrame;            //  
int eFrame;            //  
int bSample;           //  
int eSample;           //  
int MinBars;           // 

bool FirstFrame;       //

int pos,pos0;          // 
double Y[];            // 
//double YY[];           // 
int FPtr;              // 
double SumY;           //
double SumXY;          //
//double SumYY;          //
double A;              //
double B;              //
double N1,N2,F1;          //
double N3,N4;          //

int BTime,ETime;

double Buf[];

double Lwma_Sma[];


int init() {

   if (Frame < 3) {
     Alert("MovingLR:  Frame    2");
     return(0);
   }  
   PreBars = 0;
   BarTime = 0;
   MinBars = Shift+Frame+1;
   ArrayResize(Y,Frame);
//   ArrayResize(YY,Frame);

   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Buf);
   
//   SetIndexStyle(1,DRAW_LINE);
//   SetIndexBuffer(1,Lwma_Sma);

   F1 = Frame-1;
   N1 = (Frame+F1)/3.0;
   N2 = Frame*(Frame+1);
   N2 = 6.0/N2;
   N3 = (Frame-1)/2.0;
   N4 = Frame*(Frame*Frame-1);
   N4 = 12.0/N4;
 
   ObjectCreate(OName,OBJ_TREND,0,0,0,0);

   return(0);
}

int deinit() {
  ObjectDelete(OName);
  return(0);
}
 
//+------------------------------------------------------------------+
//| Custom indicator reset function                                  |
//+------------------------------------------------------------------+
int Reset() {
  FirstFrame = true;
  eSample = Shift+Frame;
  bSample = eSample+Sample-1;
  if (bSample > Bars-1 || Sample == 0) bSample = Bars-1;
  return(bSample);
}

int start() {  
  if (Bars == PreBars) return(0);
  if (Bars < MinBars) {
    Alert("MovingLR:    ");
    return(0);
  }  
  if (Bars-PreBars == 1 && BarTime==Time[1]) bSample = Frame+Shift;
  else bSample = Reset();
  PreBars = Bars;  
  BarTime=Time[0];
//  BTime = GetTickCount();
  for(bFrame = bSample; bFrame >= eSample; bFrame--) {
    eFrame = bFrame-F1;
    if (FirstFrame) {
      FirstFrame = false;
      SumY=0.0;
      SumXY=0.0;
//      SumYY=0.0;
      for (pos = eFrame; pos <= bFrame; pos++) {
        FPtr = pos-eFrame;
        Y[FPtr] = 0.5*(High[pos]+Low[pos]);
//        YY[FPtr] = Y[FPtr]*Y[FPtr];
        SumY = SumY + Y[FPtr];
//        SumYY = SumYY + YY[FPtr];
        SumXY = SumXY + FPtr*Y[FPtr];
      }
    } else {  //  if (FirstFrame)
      SumY = SumY - Y[FPtr];
      SumXY = SumXY - F1*Y[FPtr];
      Y[FPtr] = 0.5*(High[eFrame]+Low[eFrame]);
      SumXY = SumXY + SumY;
      SumY = SumY + Y[FPtr];
//      SumYY = SumYY - YY[FPtr];
//      YY[FPtr] = Y[FPtr]*Y[FPtr];
//      SumYY = SumYY + YY[FPtr];
      FPtr--;
      if (FPtr < 0) FPtr = F1;
    }  // else {  //  if (FirstFrame) 
    A = (SumXY - N3*SumY)*N4;
    B = (N1*SumY - SumXY)*N2;
    Buf[eFrame] = B;
    
  }  // for(bFrame = bSample; bFrame < eSample; bFrame++)
//  ETime = GetTickCount();
//  Print("Moving LR: ",ETime-BTime,"ms");

  
//  bFrame++;
  ObjectSet(OName,OBJPROP_TIME1,Time[bFrame]);
  ObjectSet(OName,OBJPROP_PRICE1,A*(Frame-1)+B);
  ObjectSet(OName,OBJPROP_TIME2,Time[eFrame]);
  ObjectSet(OName,OBJPROP_PRICE2,B);

/*
  BTime = GetTickCount();
  for( int i = Bars - 1; i >= 0; i-- ) 
  {  
      Lwma_Sma[ i ] = 3* iMA( NULL, 0, Frame, Shift, MODE_LWMA, PRICE_MEDIAN, i ) - 
                      2* iMA( NULL, 0, Frame, Shift, MODE_SMA,  PRICE_MEDIAN, i ); 
  }
  ETime = GetTickCount();
//  Print("LRMA: ",ETime-BTime,"ms");
*/  
  return(0);
}